/*
 * MonthlyFactory.java
 *
 * Created on October 15, 2006, 10:09 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package monthlyitems;

/**
 *
 * @author Brandan
 */
public class MonthlyFactory {
    
    /** Creates a new instance of MonthlyFactory */
    public MonthlyFactory() {
    }
    
    // implementation of factory method.
    public static MonthlyCommand createMonthlyCommand(String name) throws Exception {
        try {
            // Dynamically create an object to handle the file.
            // As we get new types of files, we simply make new classses to handle them.
            return (MonthlyCommand) Class.forName("monthlyitems." + name).newInstance();
        // Log exceptions and re-throw.
        } catch (ClassNotFoundException e) {
            System.out.println("Attempting to process an unknown file type.  Name: " + name);
            throw e;
        } catch (InstantiationException e) {
            System.out.println("Unable to process this file.  Name: " + name);
            throw e;
        }
        
    }
    
}
